; Set this Equate to 1 during development phase to bypass the 
; Flash verification of bootloader
DEBUG:     EQU   0

; Change Bootloader Keys Here
KEY1:      EQU   0x00
KEY2:      EQU   0x01
KEY3:      EQU   0x02
KEY4:      EQU   0x03
KEY5:      EQU   0x04
KEY6:      EQU   0x05
KEY7:      EQU   0x06
KEY8:      EQU   0x07

; Signature Sequence to indicate Bootload mode
SIGNATURE0:    EQU    0x95
SIGNATURE1:    EQU    0x25

; Starting Address of User Code
START_ADDRESS:      EQU   0x0080
NUMBER_OF_BLOCKS:   EQU   74
CHECKSUM_ADDR_L:    EQU   0x1FFF
CHECKSUM_ADDR_H:    EQU   0x1FFE

; Boot Timeout constant.  
; The timeout is based on an 8Hz Sleep interval.  So for a timeout
; of 1 second, this value has to be 8
BOOT_TIMEOUT:      EQU   40

; Bootloader commands
COMMAND_ENTER_BOOTLOAD:   EQU   38H
COMMAND_FLASH_WRITE:      EQU   39H
COMMAND_FLASH_VERIFY:     EQU   3AH
COMMAND_BOOTLOAD_DONE:    EQU   3BH

; Boot Loader Error Codes
BOOT_COMPLETED_OK:        EQU   01H
IMAGE_VERIFY_ERROR:       EQU   02H
FLASH_CHECKSUM_ERROR:     EQU   04H
FLASH_PROTECTION_ERROR:   EQU   08H
COMM_CHECKSUM_ERROR:      EQU   10H
BOOTLOAD_MODE:            EQU   20H
INVALID_KEY:              EQU   40h    ; Set on invalid key received
INVALID_COMMAND_ERROR:    EQU   80h


