<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">
  <xsl:output method="text" omit-xml-declaration="yes" encoding="UTF-8"/>
  <!--
    This template scans the USB_DEVICE tree and counts
    the maximum number of interfaces across any single
    configuration.  One use for this number is to set
    the RAM allocation for arrays that are related to
    the number of USB_INTERFACEs active for one
    USB_CONFIGURATION. -->
  <xsl:template match="MAX_NUM_INTERFACES">
<xsl:call-template name="max-num-interfaces">
      <xsl:with-param name="NUM" select="@PARAM0"/>
    </xsl:call-template>
  </xsl:template>
  <xsl:template name="max-num-interfaces">
    <xsl:param name="NUM" select="0"/>
    <xsl:choose>
      <xsl:when test="count(child::USB_ROOT/USB_DEVICE/USB_CONFIGURATION/USB_INTERFACE[@NUMBER = $NUM]) > 0">
        <xsl:call-template name="max-num-interfaces">
          <xsl:with-param name="NUM" select="$NUM+1"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$NUM"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
