<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:template match="/">
<!--
******************************************************************************
******************************************************************************
**  FILENAME: LPF227.xsl
**   Version: 1.5, Updated on 2006/06/19 at 11:43:56
**
**  DESCRIPTION: MUMGUI stylesheet for topology selection of 2nd-Order
**               switched capacitor low-pass filters
** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
**      Copyright (c) Cypress MicroSystems 2002-2003. All Rights Reserved.
******************************************************************************
******************************************************************************
-->

<html>
<head>
   <style>
       DIV.page { page-break-before: always }
   </style>

   <script language="JavaScript">
   <![CDATA[

      var g_strUM         = "";
      var g_el            = "";


      /*********************************************************************
      * setSelection
      *   Required MUM Interface called by OnClick. It is also called by the
      *   MUMGUI to initialize the current selection (if any).
      **********************************************************************/
      function setSelection(str_UM)
      {
         g_strUM = str_UM;
      }

      /*********************************************************************
      * getSelection
      *   Required MUM Interface called by MUMGUI parent when Select
      *   button is clicked.
      **********************************************************************/
      function getSelection(x)
      {
         var sRet = new String(g_strUM);
         return   sRet;
      }

      /*********************************************************************
      * loadThis
      *   Called by Onload; used for initialization. "Clicks" the radio
      *   button associated with the currently selected topology. If there
      *   is no current selection, pick an arbitrary UM so that some button
      *   does get filled in.
      **********************************************************************/
      function loadThis()
      {
         var sArbitraryUM = "USBCY7C63HID";

         if (g_strUM == "") {
            g_strUM = sArbitraryUM;
         }

         var radioButton = document.getElementById(g_strUM);
         if (radioButton != null) {
            radioButton.click();
         }
      }
   ]]>

   </script>
</head>
<body onload="loadThis()">

<xsl:for-each select="//USER_MODULE">
   <div>
      <h2> <xsl:value-of select="@DISPLAY_NAME" /> </h2>
   </div>

   <div style="media=print;
        font-family:Tahoma,Arial,sans-serif;
        text-align:left;
        font-weight:regular">
      <p>
        Choose USB Device Class support and click the 'OK' button or click
        'Cancel,' below.
      </p>
   </div>

   <table border="0" cellspacing="20">
   <xsl:for-each select="//MULTI_MODULE">
      <tr align="center">
         <td width="150" valign="top">
            <input type="radio">
               <xsl:attribute name="value"><xsl:value-of select="@NAME" />_BTN</xsl:attribute>
               <xsl:attribute name="id"><xsl:value-of select="@NAME" /></xsl:attribute>
               <xsl:attribute name="name">TopologyButton</xsl:attribute>
               <xsl:attribute name="onClick">setSelection('<xsl:value-of select="@NAME" />')</xsl:attribute>
            </input>
            <div STYLE="media=print;
                  font-family:Tahoma,Arial,sans-serif;
                  text-align:center;
                  font-weight:bold">
                <xsl:value-of select="@DISPLAY_NAME" />
            </div>
         </td>
         <td valign="top">
            <div style="media=print;
                 font-family:Tahoma,Arial,sans-serif;
                 text-align:left;
                 font-weight:regular">
               <xsl:value-of select="@DESC" />
            </div>
         </td>
      </tr>
   </xsl:for-each>
   </table>

</xsl:for-each>

</body>
</html>
</xsl:template>
</xsl:stylesheet>
