//*****************************************************************************
//*****************************************************************************
//  FILENAME: `@INSTANCE_NAME`.h
//   Version: 1.5, Updated on 2006/06/19 at 11:43:56
//  `@PSOC_VERSION`
//
//  DESCRIPTION: USB User Module C Language interface file
//               for the enCoRe II family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

//-------------------------------------------------
// USB Device type support for the `@INSTANCE_NAME` API.
//-------------------------------------------------

//-------------------------------------------------
// fastcall16 qualifiers for the `@INSTANCE_NAME` API.
//-------------------------------------------------
#pragma fastcall16 `@INSTANCE_NAME`_Start
#pragma fastcall16 `@INSTANCE_NAME`_Stop
#pragma fastcall16 `@INSTANCE_NAME`_bCheckActivity
#pragma fastcall16 `@INSTANCE_NAME`_bGetConfiguration
#pragma fastcall16 `@INSTANCE_NAME`_bGetEPState
#pragma fastcall16 `@INSTANCE_NAME`_bGetEPCount
#pragma fastcall16 `@INSTANCE_NAME`_XLoadEP
#pragma fastcall16 `@INSTANCE_NAME`_EnableOutEP
#pragma fastcall16 `@INSTANCE_NAME`_DisableOutEP
#pragma fastcall16 `@INSTANCE_NAME`_EnableEP
#pragma fastcall16 `@INSTANCE_NAME`_DisableEP
#pragma fastcall16 `@INSTANCE_NAME`_Force
#pragma fastcall16 `@INSTANCE_NAME`_Suspend
#pragma fastcall16 `@INSTANCE_NAME`_Resume
#pragma fastcall16 `@INSTANCE_NAME`_bRWUEnabled

//-------------------------------------------------
// fastcall16 qualifiers for the HID Class API.
//-------------------------------------------------
#pragma fastcall16 `@INSTANCE_NAME`_UpdateHIDTimer
#pragma fastcall16 `@INSTANCE_NAME`_bGetProtocol

//-------------------------------------------------
// Prototypes of the `@INSTANCE_NAME` API.
//-------------------------------------------------
extern void `@INSTANCE_NAME`_Start(BYTE);
extern void `@INSTANCE_NAME`_Stop(void);
extern BYTE `@INSTANCE_NAME`_bCheckActivity(void);
extern BYTE `@INSTANCE_NAME`_bGetConfiguration(void);
extern BYTE `@INSTANCE_NAME`_bGetEPState(BYTE);
extern BYTE `@INSTANCE_NAME`_bGetEPCount(BYTE);
extern void `@INSTANCE_NAME`_XLoadEP(BYTE*);
extern void `@INSTANCE_NAME`_EnableOutEP(BYTE);
extern void `@INSTANCE_NAME`_DisableOutEP(BYTE);
extern void `@INSTANCE_NAME`_EnableEP(BYTE);
extern void `@INSTANCE_NAME`_DisableEP(BYTE);
extern void `@INSTANCE_NAME`_Force(BYTE);
extern void `@INSTANCE_NAME`_Suspend(void);
extern void `@INSTANCE_NAME`_Resume(void);
extern BYTE `@INSTANCE_NAME`_bRWUEnabled(void);

//-------------------------------------------------
// HID Class Prototypes of the `@INSTANCE_NAME` API.
//-------------------------------------------------
extern BYTE `@INSTANCE_NAME`_UpdateHIDTimer(BYTE);
extern BYTE `@INSTANCE_NAME`_bGetProtocol(BYTE);

//-------------------------------------------------
// Constants for `@INSTANCE_NAME` API's.
//-------------------------------------------------
#define NO_EVENT_ALLOWED               2
#define EVENT_PENDING                  1
#define NO_EVENT_PENDING               0

#define IN_BUFFER_FULL                 NO_EVENT_PENDING
#define IN_BUFFER_EMPTY                EVENT_PENDING
#define OUT_BUFFER_FULL                EVENT_PENDING
#define OUT_BUFFER_EMPTY               NO_EVENT_PENDING

#define USB_FORCE_J                    0x02
#define USB_FORCE_K                    0x01
#define USB_FORCE_SE0                  0x00
#define USB_FORCE_NONE                 0xFF

#define USB_IDLE_TIMER_RUNNING         0x02
#define USB_IDLE_TIMER_EXPIRED         0x01
#define USB_IDLE_TIMER_INDEFINITE      0x00

//-----------------------------------------------
// Transfer Completion Notification
//-----------------------------------------------
#define USB_XFER_IDLE                       0x00
#define USB_XFER_STATUS_ACK                 0x01
#define USB_XFER_PREMATURE                  0x02
#define USB_XFER_ERROR                      0x03

typedef struct {
    BYTE bStatus;
    WORD wLength;  
} T_USB_XFER_STATUS_BLOCK;

//-------------------------------------------------
// `@INSTANCE_NAME` Global helper variables for speed
//-------------------------------------------------
extern BYTE `@INSTANCE_NAME`_APIEPNumber;
extern BYTE `@INSTANCE_NAME`_APICount;

//-------------------------------------------------
// `@INSTANCE_NAME` Macro 'Functions'
//-------------------------------------------------
#define `@INSTANCE_NAME`_LoadEP(ep,s,c)    \
    `@INSTANCE_NAME`_APIEPNumber = ep;     \
    `@INSTANCE_NAME`_APICount = c;         \
    `@INSTANCE_NAME`_XLoadEP(s)

// end of file `@INSTANCE_NAME`.h
