/********************************************************************
 * Globals
 *
 ********************************************************************/
var g_PowerMap = new map();
g_PowerMap .add("Bus Powered", 0);
g_PowerMap .add("Self Powered", 1);

var g_DisableEnableMap = new map();
g_DisableEnableMap .add("Disabled", 0);
g_DisableEnableMap .add("Enabled", 1);

var g_DeviceClassMap = new map()
g_DeviceClassMap.add("Defined in Interface Descriptor", 0);
//g_DeviceClassMap.add("Communications", 2);
//g_DeviceClassMap.add("HUB", 9);
g_DeviceClassMap.add("Vendor-Specific", 0xFF);


var g_InterfaceClassMap = new map();
g_InterfaceClassMap.add("Undefined",0);
//g_InterfaceClassMap.add("Audio",1);
//g_InterfaceClassMap.add("CDC-Control",2);
g_InterfaceClassMap.add("HID", 3);
//g_InterfaceClassMap.add("Physical",5);
//g_InterfaceClassMap.add("Image", 6);
//g_InterfaceClassMap.add("Printer", 7);
//g_InterfaceClassMap.add("Mass-Storage",8);
//g_InterfaceClassMap.add("HUB", 9);
//g_InterfaceClassMap.add("CDC-Data", 0x0A);
//g_InterfaceClassMap.add("Chip/Smart Card", 0x0B);
//g_InterfaceClassMap.add("Content-Security", 0x0D);
//g_InterfaceClassMap.add("Video", 0x0E);
g_InterfaceClassMap.add("Vendor-Specific", 0xFF);

var g_InterfaceSubClassMap = new map();	// These subclass values only apply to HID Class
g_InterfaceSubClassMap.add("No Subclass",0);
g_InterfaceSubClassMap.add("Boot Interface Subclass",1);

var g_InterfaceProtocolMap = new map();	// These protocol values only apply to HID Class
g_InterfaceProtocolMap.add("None",0);
g_InterfaceProtocolMap.add("Keyboard",1);
g_InterfaceProtocolMap.add("Mouse",2);

var g_CountryCodeMap = new map();	
g_CountryCodeMap.add("Not Supported",0);
g_CountryCodeMap.add("US",33);

var g_EndpointTransferTypeMap = new map();
g_EndpointTransferTypeMap.add("CTRL", 0);
g_EndpointTransferTypeMap.add("INT", 3);
g_EndpointTransferTypeMap.add("ISOC", 1);
g_EndpointTransferTypeMap.add("BULK", 2);

var g_EndpointNumberMap = null;

var  g_EndpointDirectionMap = new map();
g_EndpointDirectionMap.add("IN", 1);
g_EndpointDirectionMap.add("OUT", 0);

var  g_EndpointSyncTypeMap = new map();
g_EndpointSyncTypeMap.add("No Synchronization", 0);
g_EndpointSyncTypeMap.add("Asynchronous", 1);
g_EndpointSyncTypeMap.add("Adaptive", 2);
g_EndpointSyncTypeMap.add("Synchronous", 3);

var  g_EndpointUsageTypeMap = new map();
g_EndpointUsageTypeMap.add("Data endpoint", 0);
g_EndpointUsageTypeMap.add("Feedback endpoint", 1);
g_EndpointUsageTypeMap.add("Implicit feedback Data Endpoint", 2);

var  g_HIDDescriptorTypeMap = new map();
g_HIDDescriptorTypeMap.add("Report", 0x22);
g_HIDDescriptorTypeMap.add("Physical", 0x23);

// XML Element and Attribute names
var s_USB_ROOT					= "USB_ROOT";
var s_USB_DEVICE					= "USB_DEVICE";
var s_USB_CONFIGURATION		= "USB_CONFIGURATION";
var s_USB_INTERFACE				= "USB_INTERFACE";
var s_USB_ENDPOINT				= "USB_ENDPOINT";
var s_USB_HID						= "USB_HID";
var s_ATTRIB_NAME				= "NAME"; 
var s_ATTRIB_NUMBER				= "NUMBER"; 
var s_ATTRIB_INSTANCE_NAME      = "INSTANCE_NAME"; 
var s_ATTRIB_MAX_POWER			= "MAX_POWER";
var	s_ATTRIB_SELF_POWERED		= "SELF_POWERED";
var	s_ATTRIB_REMOTE_WAKEUP      = "REMOTE_WAKEUP";
var	s_ATTRIB_STRING				= "STRING";
var	s_DEFAULT_STRING			= "0";
var	s_ATTRIB_CLASS				= "CLASS";
var	s_ATTRIB_SUBCLASS			= "SUBCLASS";
var	s_ATTRIB_PROTOCOL			= "PROTOCOL";
var	s_ATTRIB_COUNTRY_CODE		= "COUNTRY_CODE";
var s_ATTRIB_HID_DESCR_TYPE	= "HID_DESCR_TYPE";
var	s_ATTRIB_TRANSFER_TYPE	= "TRANSFER_TYPE";
var	s_ATTRIB_DIRECTION			= "DIRECTION";
var	s_ATTRIB_ADDRESS			= "ADDRESS";
var s_ATTRIB_MAX_PACKET_SIZE	= "MAX_PACKET_SIZE";
var s_ATTRIB_INTERVAL			= "INTERVAL";
var s_ATTRIB_SYNC_TYPE			= "SYNC_TYPE";
var s_ATTRIB_USAGE_TYPE		= "USAGE_TYPE";
var s_ATTRIB_ID_VENDOR		= "VENDOR_ID";
var s_ATTRIB_ID_PRODUCT		= "PRODUCT_ID";
var s_ATTRIB_BCD_DEVICE		= "DEVICE_RELEASE";
var s_ATTRIB_I_VENDOR		= "VENDOR_STRING";
var s_ATTRIB_I_PRODUCT		= "PRODUCT_STRING";
var s_ATTRIB_I_SN		= "SN_STRING";
var s_ATTRIB_I_CONFIGURATION = "CONFIGURATION_STRING";
var s_ATTRIB_I_INTERFACE	= "INTERFACE_STRING";
var s_ATTRIB_HID_REPORT		= "HID_REPORT";
// New objects

/*********************************************************************
 * Class: USBRoot
 *
 *********************************************************************/
function USBRoot()
{
	this.instance_name = '';
	this.next_hash  = 0;
	this.devices = new Array();
}
/*********************************************************************
 * Method: USBRoot.prototype.serializeIn
 *
 *********************************************************************/
USBRoot.prototype.serializeIn = function (xmlElement)
{
	this.instance_name	= serializeInFromString(xmlElement.getAttribute(s_ATTRIB_INSTANCE_NAME), "");
	this.next_hash		= serializeInFromString(xmlElement.getAttribute(s_ATTRIB_NEXT_HASH), 0);
	var devices = xmlElement.getElementsByTagName(s_USB_DEVICE);
	for (var i = 0; i < devices.length; i++)	// >
	{
		this.devices[i] = new USBDevice("");
		this.devices[i].serializeIn(devices[i]);
	}
}
/*********************************************************************
 * Method: USBRoot.prototype.serializeOut
 *
 *********************************************************************/
USBRoot.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_USB_ROOT);
	xmlElement.setAttribute(s_ATTRIB_NEXT_HASH,			this.next_hash);

	xmlElement.setAttribute(s_ATTRIB_INSTANCE_NAME,				this.instance_name);
	
	for (var i = 0; i < this.devices.length; i++)	// >
	{
		this.devices[i].number = i;
		xmlElement.appendChild(this.devices[i].serializeOut (xmlDoc));	
	}
	return xmlElement;
}
/*********************************************************************
 * Method: USBRoot.prototype.addDevice
 *
 *********************************************************************/
USBRoot.prototype.addDevice = function ()
{
	this.devices[this.devices.length] = new USBDevice(this.next_hash++);
}
/*********************************************************************
 * Method: USBRoot.prototype.deleteDevice
 *
 *********************************************************************/
USBRoot.prototype.deleteDevice = function (num)
{
	if ((num >= 0) && (num < this.devices.length))	// >
	{
		this.devices.splice(num, 1);
	}
}
/*********************************************************************
 * Class: USBDevice
 *
 *********************************************************************/
function USBDevice(number)
{
//	debugBox("USBDevice::Entered");
	this.name = 'D' + number;
	this.number = number;
	this.next_hash  = 0;
	this.USBclass = g_DeviceClassMap.pairs["Defined in Interface Descriptor"].first;
	this.subclass = g_InterfaceSubClassMap.pairs["No Subclass"].first;
	this.protocol = g_InterfaceProtocolMap.pairs["None"].first;
	this.maxPacketSize0 = 8;
	this.idVendor = "FFFF";
	this.idProduct= "FFFF";
	this.bcdDevice = "0000";
	
	this.iManufacturer	= 0;
	this.iProduct		= 0;
	this.iSerialNumber	= 0;

	this.configs = new Array();
}
/*********************************************************************
 * Method: USBDevice.prototype.serializeIn
 *
 *********************************************************************/
USBDevice.prototype.serializeIn = function (xmlElement)
{
	this.name     = xmlElement.getAttribute(s_ATTRIB_NAME);
	this.number     = xmlElement.getAttribute(s_ATTRIB_NUMBER);
	this.next_hash  = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_NEXT_HASH), 0);
	this.USBclass  = serializeInFromMap(g_DeviceClassMap, xmlElement.getAttribute(s_ATTRIB_CLASS), g_InterfaceClassMap.pairs["Vendor-Specific"].first);
	this.subclass  = serializeInFromMap(g_InterfaceSubClassMap, xmlElement.getAttribute(s_ATTRIB_SUBCLASS), g_InterfaceSubClassMap.pairs["No Subclass"].first);
	this.protocol  = serializeInFromMap(g_InterfaceProtocolMap, xmlElement.getAttribute(s_ATTRIB_PROTOCOL), g_InterfaceProtocolMap.pairs["None"].first);


	this.iManufacturer  = serializeInFromMap(g_StringMap, xmlElement.getAttribute(s_ATTRIB_I_VENDOR), g_StringMap.reverse_lookup(0));
	this.iProduct		= serializeInFromMap(g_StringMap, xmlElement.getAttribute(s_ATTRIB_I_PRODUCT), g_StringMap.reverse_lookup(0));
	this.iSerialNumber  = serializeInFromMap(g_StringMap, xmlElement.getAttribute(s_ATTRIB_I_SN), g_StringMap.reverse_lookup(0));

	this.maxPacketSize0   = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_MAX_PACKET_SIZE), 8);
	this.idVendor    = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_ID_VENDOR), "FFFF");
	this.idProduct   = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_ID_PRODUCT), "FFFF");
	this.bcdDevice   = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_BCD_DEVICE), "0000");

	
	var configs = xmlElement.getElementsByTagName(s_USB_CONFIGURATION);
	for (var i = 0; i < configs.length; i++)	// >
	{
		this.configs[i] = new USBConfiguration("");
		this.configs[i].serializeIn(configs[i]);
	}
}
/*********************************************************************
 * Method: USBDevice.prototype.serializeOut
 *
 *********************************************************************/
USBDevice.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_USB_DEVICE);
	// Add default attributes here
	xmlElement.setAttribute(s_ATTRIB_NAME,              'D'+this.number);
	xmlElement.setAttribute(s_ATTRIB_NUMBER,			this.number);
	xmlElement.setAttribute(s_ATTRIB_NEXT_HASH,			this.next_hash);
	xmlElement.setAttribute(s_ATTRIB_CLASS,				g_DeviceClassMap.pairs[this.USBclass].second);
	xmlElement.setAttribute(s_ATTRIB_SUBCLASS,			g_InterfaceSubClassMap.pairs[this.subclass].second);
	xmlElement.setAttribute(s_ATTRIB_PROTOCOL,			g_InterfaceProtocolMap.pairs[this.protocol].second);
	try {
		xmlElement.setAttribute(s_ATTRIB_I_VENDOR,			g_StringMap.pairs[this.iManufacturer].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_I_VENDOR,		0);
	}
	try {
		xmlElement.setAttribute(s_ATTRIB_I_PRODUCT,			g_StringMap.pairs[this.iProduct].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_I_PRODUCT,		0);
	}
	try {
		xmlElement.setAttribute(s_ATTRIB_I_SN,				g_StringMap.pairs[this.iSerialNumber].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_I_SN,		0);
	}

	xmlElement.setAttribute(s_ATTRIB_MAX_PACKET_SIZE,	this.maxPacketSize0);

	xmlElement.setAttribute(s_ATTRIB_ID_VENDOR,			this.idVendor);
	xmlElement.setAttribute(s_ATTRIB_ID_PRODUCT,		this.idProduct);
	xmlElement.setAttribute(s_ATTRIB_BCD_DEVICE,		this.bcdDevice);

	for (var i = 0; i < this.configs.length; i++)	// >
	{
		this.configs[i].number = i + 1; // Configuration number starts at 1
		xmlElement.appendChild(this.configs[i].serializeOut (xmlDoc));	
	}
	return xmlElement;
}
/*********************************************************************
 * Method: USBDevice.prototype.addConfig
 *
 *********************************************************************/
USBDevice.prototype.addConfig = function ()
{
	this.configs[this.configs.length] = new USBConfiguration(++this.next_hash);
}
/*********************************************************************
 * Method: USBDevice.prototype.deleteConfig
 *
 *********************************************************************/
USBDevice.prototype.deleteConfig = function (num)
{
	if ((num >= 0) && (num < this.configs.length))	// >
	{
		this.configs.splice(num, 1);
	}
}
/*********************************************************************
 * Class: USBConfiguration
 *
 *********************************************************************/
function USBConfiguration(number)
{
	this.name = 'C' + number;
	this.number = number;
	this.next_hash  = 0;
	this.interfaces = new Array();
	this.iConfiguration = 0;
	this.power_source = g_PowerMap.pairs["Bus Powered"].first;
	this.remote_wakeup = g_DisableEnableMap.pairs["Disabled"].first;
	this.max_power = 100;
}
/*********************************************************************
 * Method: USBConfiguration.prototype.serializeIn
 *
 *********************************************************************/
USBConfiguration.prototype.serializeIn = function (xmlElement)
{
	this.name     = xmlElement.getAttribute(s_ATTRIB_NAME);
	this.number         = xmlElement.getAttribute(s_ATTRIB_NUMBER);
	this.next_hash		= serializeInFromString(xmlElement.getAttribute(s_ATTRIB_NEXT_HASH), 0);
	this.iConfiguration = serializeInFromMap(g_StringMap, xmlElement.getAttribute(s_ATTRIB_I_CONFIGURATION), g_StringMap.reverse_lookup(0));
	this.max_power      = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_MAX_POWER), 100);
	this.power_source   = serializeInFromMap(g_PowerMap, xmlElement.getAttribute(s_ATTRIB_SELF_POWERED), g_PowerMap.pairs["Bus Powered"].first);
	this.remote_wakeup  = serializeInFromMap(g_DisableEnableMap, xmlElement.getAttribute(s_ATTRIB_REMOTE_WAKEUP), g_DisableEnableMap.pairs["Disabled"].first);
    this.string         = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_STRING), 0);
    
	var interfaces = xmlElement.getElementsByTagName(s_USB_INTERFACE);
	for (var i = 0; i < interfaces.length; i++)	// >
	{
		this.interfaces[i] = new USBInterface("");
		this.interfaces[i].serializeIn(interfaces[i]);
	}
}
/*********************************************************************
 * Method: USBConfiguration.prototype.serializeOut
 *
 *********************************************************************/
USBConfiguration.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement=xmlDoc.createElement(s_USB_CONFIGURATION);
	// Add default attributes here
	xmlElement.setAttribute(s_ATTRIB_NAME,              'C'+ this.number);
	xmlElement.setAttribute(s_ATTRIB_NUMBER,            this.number);
	xmlElement.setAttribute(s_ATTRIB_NEXT_HASH,			this.next_hash);
	try {
		xmlElement.setAttribute(s_ATTRIB_I_CONFIGURATION,	g_StringMap.pairs[this.iConfiguration].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_I_CONFIGURATION,	0);
	}
	xmlElement.setAttribute(s_ATTRIB_MAX_POWER,			this.max_power);
	xmlElement.setAttribute(s_ATTRIB_SELF_POWERED,		g_PowerMap.pairs[this.power_source].second);
	xmlElement.setAttribute(s_ATTRIB_REMOTE_WAKEUP,	g_DisableEnableMap.pairs[this.remote_wakeup].second);
	xmlElement.setAttribute(s_ATTRIB_STRING,			0);		
	for (var i = 0; i < this.interfaces.length; i++)	// >
	{
		this.interfaces[i].number = i;  // Make sure the proper numbering is done
		xmlElement.appendChild(this.interfaces[i].serializeOut (xmlDoc));	
	}
	return xmlElement;
}
/*********************************************************************
 * Method: USBConfiguration.prototype.addInterface
 *
 *********************************************************************/
USBConfiguration.prototype.addInterface = function (xmlElement)
{
	this.interfaces[this.interfaces.length] = new USBInterface(this.next_hash++);
}
/*********************************************************************
 * Method: USBConfiguration.prototype.deleteInterface
 *
 *********************************************************************/
USBConfiguration.prototype.deleteInterface = function (num)
{
	if ((num >= 0) && (num < this.interfaces.length))	// >
	{
		this.interfaces.splice(num, 1);
	}
}
/*********************************************************************
 * Class: USBInterface
 *
 *********************************************************************/
function USBInterface(number)
{
	this.name = 'I' + number;
	this.number = number;
	this.next_hash  = 0;
	this.iInterface = 0;
	this.USBclass = g_InterfaceClassMap.pairs["Undefined"].first;
	this.subclass = g_InterfaceSubClassMap.pairs["No Subclass"].first;
	this.protocol = g_InterfaceProtocolMap.pairs["None"].first;
	this.class_descr = null;
	this.endpoints = new Array();
	this.string = 0;
}
/*********************************************************************
 * Method: USBInterface.prototype.serializeIn
 *
 *********************************************************************/
USBInterface.prototype.serializeIn = function (xmlElement)
{
	this.name     = xmlElement.getAttribute(s_ATTRIB_NAME);
	this.number    = xmlElement.getAttribute(s_ATTRIB_NUMBER);
	this.next_hash		= serializeInFromString(xmlElement.getAttribute(s_ATTRIB_NEXT_HASH), 0);
	this.iInterface = serializeInFromMap(g_StringMap, xmlElement.getAttribute(s_ATTRIB_I_INTERFACE), g_StringMap.reverse_lookup(0));
	this.USBclass  = serializeInFromMap(g_InterfaceClassMap, xmlElement.getAttribute(s_ATTRIB_CLASS), g_InterfaceClassMap.pairs["Vendor-Specific"].first);
	this.subclass  = serializeInFromMap(g_InterfaceSubClassMap, xmlElement.getAttribute(s_ATTRIB_SUBCLASS), g_InterfaceSubClassMap.pairs["No Subclass"].first);
	this.protocol  = serializeInFromMap(g_InterfaceProtocolMap, xmlElement.getAttribute(s_ATTRIB_PROTOCOL), g_InterfaceProtocolMap.pairs["None"].first);
    this.string    = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_STRING), 0);
   
	
    var class_descr = xmlElement.getElementsByTagName(s_USB_HID);
    
    if (class_descr.length != 0)
    {
        this.class_descr = new USBClassHID(0);
        this.class_descr.serializeIn(class_descr[0]);
    }

    var endpoints = xmlElement.getElementsByTagName(s_USB_ENDPOINT);
	for (var i = 0; i < endpoints.length; i++)	// >
	{
		this.endpoints[i] = new USBEndpoint(i);
		this.endpoints[i].serializeIn(endpoints[i]);
	}
}
/*********************************************************************
 * Method: USBInterface.prototype.serializeOut
 *
 *********************************************************************/
USBInterface.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement=xmlDoc.createElement(s_USB_INTERFACE);
	// Add default attributes here
	xmlElement.setAttribute(s_ATTRIB_NAME,              'I'+ this.number);
	xmlElement.setAttribute(s_ATTRIB_NUMBER,            this.number);
	xmlElement.setAttribute(s_ATTRIB_NEXT_HASH,			this.next_hash);
	try {
		xmlElement.setAttribute(s_ATTRIB_I_INTERFACE,		g_StringMap.pairs[this.iInterface].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_I_INTERFACE,		0);
	}

	xmlElement.setAttribute(s_ATTRIB_CLASS,				g_InterfaceClassMap.pairs[this.USBclass].second);
	xmlElement.setAttribute(s_ATTRIB_SUBCLASS,			g_InterfaceSubClassMap.pairs[this.subclass].second);
	xmlElement.setAttribute(s_ATTRIB_PROTOCOL,			g_InterfaceProtocolMap.pairs[this.protocol].second);
	xmlElement.setAttribute(s_ATTRIB_STRING,				this.string);
	if (this.class_descr != null)
	{
		xmlElement.appendChild(this.class_descr.serializeOut (xmlDoc));	
	}
	for (var i = 0; i < this.endpoints .length; i++)	// >
	{
		this.endpoints[i].number = i;  // Make sure the proper numbering is done
		xmlElement.appendChild(this.endpoints [i].serializeOut (xmlDoc));
	}

	return xmlElement;
}
/*********************************************************************
 * Method: USBInterface.prototype.addClass
 *
 *********************************************************************/
USBInterface.prototype.addClass = function ()
{
	if (this.class_descr == null)
	{
		this.class_descr = new USBClassHID(this.number);
	}
}
/*********************************************************************
 * Method: USBInterface.prototype.deleteClass
 *
 *********************************************************************/
USBInterface.prototype.deleteClass = function ()
{
	if (this.class_descr != null)
	{
		delete this.class_descr;
		this.class_descr = null;
	}
}
/*********************************************************************
 * Method: USBInterface.prototype.addEndpoint
 *
 *********************************************************************/
USBInterface.prototype.addEndpoint = function ()
{
	this.endpoints[this.endpoints.length] = new USBEndpoint();
}
/*********************************************************************
 * Method: USBInterface.prototype.deleteEndpoint
 *
 *********************************************************************/
USBInterface.prototype.deleteEndpoint = function (num)
{
	if ((num >= 0) && (num < this.endpoints.length))	// >
	{
		this.endpoints.splice(num, 1);
	}
}
/*********************************************************************
 * Class: USBClassHID
 *
 *********************************************************************/
function USBClassHID(number)
{
	this.number = number;
	this.descr_type   = g_HIDDescriptorTypeMap.pairs["Report"].first;
	this.country_code      = g_CountryCodeMap.pairs["Not Supported"].first;
	this.hid_report = 0;
	this.reports = new Array();
}
/*********************************************************************
 * Method: USBClassHID.prototype.serializeIn
 *
 *********************************************************************/
USBClassHID.prototype.serializeIn = function (xmlElement)
{
	this.name     = xmlElement.getAttribute(s_ATTRIB_NAME);
    this.number = xmlElement.getAttribute(s_ATTRIB_NUMBER);
	this.country_code    = serializeInFromMap(g_CountryCodeMap, xmlElement.getAttribute(s_ATTRIB_COUNTRY_CODE), g_CountryCodeMap.pairs["Not Supported"].first);
	this.descr_type = serializeInFromMap(g_HIDDescriptorTypeMap, xmlElement.getAttribute(s_ATTRIB_HID_DESCR_TYPE), g_HIDDescriptorTypeMap.pairs["Report"].first);
	this.hid_report = serializeInFromMap(g_HIDReportMap, xmlElement.getAttribute(s_ATTRIB_HID_REPORT), g_HIDReportMap.reverse_lookup(0));
}
/*********************************************************************
 * Method: USBClassHID.prototype.serializeOut
 *
 *********************************************************************/
USBClassHID.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement=xmlDoc.createElement(s_USB_HID);
	// Add default attributes here
	xmlElement.setAttribute(s_ATTRIB_NUMBER,			this.number);
	xmlElement.setAttribute(s_ATTRIB_HID_DESCR_TYPE,	g_HIDDescriptorTypeMap.pairs[this.descr_type].second);
	xmlElement.setAttribute(s_ATTRIB_COUNTRY_CODE,		g_CountryCodeMap.pairs[this.country_code].second);


	try {
		xmlElement.setAttribute(s_ATTRIB_HID_REPORT,		g_HIDReportMap.pairs[this.hid_report].second);
	}
	catch (e) {
		xmlElement.setAttribute(s_ATTRIB_HID_REPORT,		0);
	}
	return xmlElement;
}
/*********************************************************************
 * Method: USBClassHID.prototype.addHIDReport
 *
 *********************************************************************/
USBClassHID.prototype.addHIDReport = function ()
{
	this.reports[this.reports.length] = new HIDReport(0);
}
/*********************************************************************
 * Method: USBClassHID.prototype.deleteHIDReport
 *
 *********************************************************************/
USBClassHID.prototype.deleteHIDReport = function (num)
{
	if ((num >= 0) && (num < this.reports.length))	// >
	{
		this.reports.splice(num, 1);
	}
}
/*********************************************************************
 * Class: USBEndpoint
 *
 *********************************************************************/
function USBEndpoint(number)
{
	this.name = 'E' + number;
	this.number           = number;
	this.address        = 1;
	this.max_packet_size = 8;
	this.interval       = 10;
	this.direction      = g_EndpointDirectionMap.pairs["IN"].first;
	this.transfer_type  = g_EndpointTransferTypeMap.pairs["INT"].first;
	this.sync_type      = g_EndpointSyncTypeMap.pairs["No Synchronization"].first;
	this.usage_type     = g_EndpointUsageTypeMap.pairs["Data endpoint"].first;
}
/*********************************************************************
 * Method: USBEndpoint.prototype.serializeIn
 *
 *********************************************************************/
USBEndpoint.prototype.serializeIn = function (xmlElement)
{
	this.number       = xmlElement.getAttribute(s_ATTRIB_NUMBER);

	this.address    = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_ADDRESS), 0);
	this.max_packet_size   
                    = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_MAX_PACKET_SIZE), 8);
	this.interval   = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_INTERVAL), 10);

	this.direction    = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_DIRECTION), 'IN');
	this.transfer_type= serializeInFromMap(g_EndpointTransferTypeMap, xmlElement.getAttribute(s_ATTRIB_TRANSFER_TYPE), g_EndpointTransferTypeMap.pairs["INT"].first);
	this.sync_type    = serializeInFromMap(g_EndpointSyncTypeMap, xmlElement.getAttribute(s_ATTRIB_SYNC_TYPE), g_EndpointSyncTypeMap.pairs["No Synchronization"].first);
	this.usage_type   = serializeInFromMap(g_EndpointUsageTypeMap, xmlElement.getAttribute(s_ATTRIB_USAGE_TYPE), g_EndpointUsageTypeMap.pairs["Data endpoint"].first);
}
/*********************************************************************
 * Method: USBEndpoint.prototype.serializeOut
 *
 *********************************************************************/
USBEndpoint.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement=xmlDoc.createElement(s_USB_ENDPOINT);
	// Add default attributes here
	xmlElement.setAttribute(s_ATTRIB_NAME,              'E'+this.number);
	xmlElement.setAttribute(s_ATTRIB_NUMBER,            this.number);
	xmlElement.setAttribute(s_ATTRIB_ADDRESS,			this.address);
	xmlElement.setAttribute(s_ATTRIB_MAX_PACKET_SIZE,	this.max_packet_size);
	xmlElement.setAttribute(s_ATTRIB_INTERVAL,			this.interval );
	xmlElement.setAttribute(s_ATTRIB_DIRECTION,			g_EndpointDirectionMap.pairs[this.direction].first);
	xmlElement.setAttribute(s_ATTRIB_TRANSFER_TYPE,		g_EndpointTransferTypeMap.pairs[this.transfer_type].second);
	xmlElement.setAttribute(s_ATTRIB_SYNC_TYPE,			g_EndpointSyncTypeMap.pairs[this.sync_type].second);
	xmlElement.setAttribute(s_ATTRIB_USAGE_TYPE,		g_EndpointUsageTypeMap.pairs[this.usage_type].second);

	return xmlElement;
}