/********************************************************************
 * Global
 *
 ********************************************************************/
var g_ps					= null;
var g_pDlg					= null;
var g_DeviceEditor			= null;
var g_ProjectManager		= null;
var g_xmlDoc				= null;
var g_sXMLPath				= null;
var g_UMPath                = null;
var g_UMTemplatePath        = null;

var g_sOverLay				= null;
var g_sUMName				= null;
var g_sInstanceName		    = null;

var g_DirRoot		        = null;
var g_Report			    = null;
var g_EditorCtrl            = null;

var g_DirTree				= null;
var g_ReportTree			= null;

var g_HIDReportMap          = null;

var g_HIDTemplateDirectory  = 'TEMPLATE_DIR.XML';
var g_HIDTemplateBase       = 'HIDTemplate_';
var g_HIDTemplatePath       = null;

var Headings = new Array(new pair(250, ''), new pair(300, 'Template Description'), new pair(250, 'Operations'));
/*********************************************************************
 * Function:	setPSoCParameter
 * * This function provide the means to update a User Module Parameter
 * inside the PSoC Designer Context
 *
 *********************************************************************/
function setPSoCParameter(paramName, paramValue)
{
    g_DeviceEditor.lSetUserModuleParameter2(g_sOverLay, g_sInstanceName, paramName, paramValue);
}
/*********************************************************************
 * Function:	getPSoCParameter
 *
 * This function provide the means to get the current value of a
 * User Module Parameter inside the PSoC Designer Context
 *
 *********************************************************************/
function getPSoCParameter(paramName)
{
    return g_DeviceEditor.GetUserModuleParameter2(g_sOverLay, g_sInstanceName, paramName);
}
/*********************************************************************
 * Function:	setPSoC
 *
 * This function is invoked by PSoC Designer to give the wizard the
 * necessary context handles for communication between the PSoC
 * Designer User Module instance and the wizard.
 *
 *********************************************************************/
function setPSoC(ps, pDlg, sOverLay, sUMName, sInstanceName)
{
	g_ps			= ps;
	g_pDlg			= pDlg;
	g_sOverLay	= sOverLay;
	g_sUMName	= sUMName;
	g_sInstanceName = sInstanceName;
    var bRet;

	if (g_ps != null)
	{
        g_xmlDoc        = g_ps.GetXMLDOM();
        g_xmlDoc.async = "false";
        g_DeviceEditor  = g_ps.GetDeviceEditor;
        g_ProjectManager= g_ps.GetProjectManager;
        g_umPath        = g_DeviceEditor.GetUserModulePath(g_sUMName);
        var regex       = new RegExp('\\\\'+g_sUMName+'\\\\');
        g_umTemplatePath= g_umPath.substring(0, g_umPath.search(regex) + g_sUMName.length + 2) + 'WIZARD\\templates\\';
        bRet = g_xmlDoc.load(g_umTemplatePath + g_HIDTemplateDirectory);
        g_DirRoot = new HIDTemplateRoot();
        if (bRet)
        {
	    	g_DirRoot.serializeIn(g_xmlDoc.documentElement);
        }
        refreshApp();
	}
    if(g_pDlg != null)
    {
        g_pDlg.SetCaption("HID Report Template Editor");
    }
}
/*********************************************************************
 * Function:	refreshApp
 *
 * This function refreshes all of the tree controls in the application.
 *
 *********************************************************************/
function refreshApp()
{
	if (g_DirRoot != null)
        g_DirTree = loadTreeX('DIRECTORY', g_DirRoot, Headings);
}
/*********************************************************************
 * The following functions may need to be refactored into other function
 * or at least moved to other locations.
 *********************************************************************/
function xmlDocOnReadyStateChange()
{
	//debugBox("xmlDocOnReadyStateChange::Entering: " + g_xmlDoc.readyState );
}

function checkDuplicateName(list,name)
{
	bDup = false;
	
	for (var i = 0; i < list.length; i++) // >
	{
		if (list[i].name == name)
		{
			bDup = true;
		}
	}
	return bDup;
}
// Data validation routines
function checkDuplicateAttribute(objList, attrib, value)
{
	var bDup = false;
	
	debugBox("checkDuplicateAttribute::Entered");
	for (var i = 0; i < objList.length; i++) //>
	{
		var l_value = objList[i].getAttribute(attrib);
		if (l_value == value)
		{
			bDup = true;
		}
	}
//	debugBox("checkDuplicateAttribute::Exiting");
	return bDup;
}