/********************************************************************
 * Global
 *
 ********************************************************************/
if (g_Enable == null)
{
    var g_Enable = new map();
    g_Enable.add("Disable",0);
    g_Enable.add("Enable",1);
}
// XML Element and Attribute names

var s_TEMPLATE_ROOT			= "TEMPLATE_ROOT";
var s_ATTRIB_NEXT_ID    	= "NEXT_ID";
var s_TEMPLATE      		= "TEMPLATE";
var s_ATTRIB_DESCRIPTION	= "DESCRIPTION";
var s_ATTRIB_ID			    = "ID";
var s_ATTRIB_ALLOW_DELETE	= "ALLOW_DELETE";
var s_ATTRIB_ALLOW_MODIFY   = "ALLOW_MODIFY";
var s_ATTRIB_LAST_DATE_SAVED= "DATE_SAVED";

/*********************************************************************
 * Global: HIDTemplateRootGlobal
 *
 *********************************************************************/
HIDTemplateRootHandler = {
	enableEditor            : true,
	enableExport            : false
}
/*********************************************************************
 * Class: HIDTemplateRoot
 *
 *********************************************************************/
function HIDTemplateRoot()
{
    this.templates      = new Array();
    this.next_id        = 1;
}
/*********************************************************************
 * Method: HIDTemplateRoot.prototype.serializeIn
 *
 *********************************************************************/
HIDTemplateRoot.prototype.serializeIn = function (xmlElement)
{
	this.next_id = xmlElement.getAttribute(s_ATTRIB_NEXT_ID);
	var templates = xmlElement.getElementsByTagName(s_TEMPLATE);
	for (var i = 0; i < templates.length; i++)	// >
	{
		this.templates[i] = new HIDTemplate(0);
		this.templates[i].serializeIn(templates[i]);
	}
}
/*********************************************************************
 * Method: HIDTemplateRoot.prototype.serializeOut
 *
 *********************************************************************/
HIDTemplateRoot.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_TEMPLATE_ROOT);
	xmlElement.setAttribute(s_ATTRIB_NEXT_ID,		    this.next_id);
	for (var i = 0; i < this.templates.length; i++)	// >
	{
		xmlElement.appendChild(this.templates[i].serializeOut (xmlDoc));	
	}
	return xmlElement;
}
/*********************************************************************
 * Method: HIDTemplateRoot.prototype.addHIDTemplate
 *
 *********************************************************************/
HIDTemplateRoot.prototype.addHIDTemplate = function ()
{
	this.templates[this.templates.length] = new HIDTemplate(this.next_id++);
	return this.templates[this.templates.length-1];
}
/*********************************************************************
 * Method: HIDTemplateRoot.prototype.deleteHIDTemplate
 *
 *********************************************************************/
HIDTemplateRoot.prototype.deleteHIDTemplate = function (num)
{
	if ((num >= 0) && (num < this.templates.length))	// >
	{
		this.templates.splice(num, 1);
	}
}
/*********************************************************************
 * Class: HIDTemplate
 *
 *********************************************************************/
function HIDTemplate(n)
{
    this.description   = 'New HID Report Description';
    this.ID            = n;
	this.allow_delete  = g_Enable.pairs["Enable"].first;
	this.allow_modify  = g_Enable.pairs["Enable"].first;
    this.date_saved    = new Date();	
}
/*********************************************************************
 * Method: HIDTemplate.prototype.serializeIn
 *
 *********************************************************************/
HIDTemplate.prototype.serializeIn = function (xmlElement)
{
    this.description   = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_DESCRIPTION), 'Edit description Here');
    this.ID            = xmlElement.getAttribute(s_ATTRIB_ID);
	this.allow_delete  = xmlElement.getAttribute(s_ATTRIB_ALLOW_DELETE);
	this.allow_modify  = xmlElement.getAttribute(s_ATTRIB_ALLOW_MODIFY);
    this.date_saved    = new Date(xmlElement.getAttribute(s_ATTRIB_LAST_DATE_SAVED));	
}
/*********************************************************************
 * Method: HIDTemplate.prototype.serializeOut
 *
 *********************************************************************/
HIDTemplate.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_TEMPLATE);

	xmlElement.setAttribute(s_ATTRIB_DESCRIPTION,		this.description);
	xmlElement.setAttribute(s_ATTRIB_ID,				this.ID);
	xmlElement.setAttribute(s_ATTRIB_ALLOW_DELETE,		this.allow_delete);
	xmlElement.setAttribute(s_ATTRIB_ALLOW_MODIFY,		this.allow_modify);
	xmlElement.setAttribute(s_ATTRIB_LAST_DATE_SAVED,   new Date());

	return xmlElement;
}
/*********************************************************************
 * Method: HIDTemplate.prototype.toString
 *
 *********************************************************************/
HIDTemplate.prototype.toString = function()
{
    sRet = new String();
    sRet += this.description;
    sRet += ':ID ' + this.ID;
    sRet += ':allow_delete ' + this.allow_delete;
	sRet += ':allow_modify ' + this.allow_modify;
    sRet += ':date_saved '   + this.date_saved;
    return sRet;
}
