/********************************************************************
 * Global
 *
 ********************************************************************/
var g_StringSubject = new Subject("USBSTRINGS");  // Subject of an observer update

/********************************************************************
 * Function: USBStrings.prototype.loadUI
 *
 ********************************************************************/
USBStrings.prototype.loadUI = function (node)
{
	var child, ot;
	child = new TreeListControlNode(true, null, '');
	var ot = '<a href="javascript:insertString('+ child.ID +');">Add String</a>';
	child.setText('String Descriptors', this.instance_name, ot);
	node.add(child);	
	// LANGID First
	this.langids[0].loadUI(child);
	// Strings Second
	for (var i = 0; i < this.strings.length; ++i)
	{
		this.strings[i].loadUI(child);
	}	
}
/********************************************************************
 * Method: USBStrings.prototype.unloadUI
 *
 ********************************************************************/
USBStrings.prototype.unloadUI = function (node)
{
	var child = node.firstChild.firstChild;

	this.instance_name = node.firstChild.columnText[1];
//  Unload the LangID.  We only support one LANGID
	this.addLANGID();
	this.langids[0].unloadUI(child);
// Check out the strings
	child = child.nextSibling;
	while (child != null)
	{
		this.addString();
		this.strings[this.strings.length - 1].unloadUI(child);
		child = child.nextSibling;
	}
}
/********************************************************************
 * Method: USBLANGIDDescr.prototype.loadUI
 *
 ********************************************************************/
USBLANGIDDescr.prototype.loadUI = function (node)
{
	var child, it;
	child = new TreeListControlNode(true, null, '');
	it = makeSelectP(g_LANGIDMap, this.langid_val, 'onLANGIDChange(this)', 'select_'+child.ID);
	child.setText('LANGID',it);
	node.add(child);	
}
/********************************************************************
 * Method: USBLANGIDDescr.prototype.unloadUI
 *
 ********************************************************************/
USBLANGIDDescr.prototype.unloadUI = function (node)
{
	this.langid_val =document.getElementById('select_'+node.ID).value;
}
/********************************************************************
 * Method: USBStringDescr.prototype.loadUI
 *
 ********************************************************************/
USBStringDescr.prototype.loadUI = function (node)
{
	var child, it, ot;
	child = new TreeListControlNode(true, null, '');
	var it = loadTextEditZ(this.str_val, 'validateStringDescr', child.ID, 'text_'+child.ID);

	var ot = '<a href="javascript:removeString(' + child.ID +');">Remove</a>';
	child.setText('String', it, ot);
	node.add(child);	
}
/********************************************************************
 * Method: USBStringDescr.prototype.unloadUI
 *
 ********************************************************************/
USBStringDescr.prototype.unloadUI = function (node)
{
	this.str_val = document.getElementById('text_'+node.ID).value;
}
/********************************************************************
 * Function: insertString
 *
 ********************************************************************/
function insertString(node_id)
{
	var str = new USBStringDescr();
	// Application layer coupling using the tree root name.
	str.str_val = 'Edit your string here';
	str.loadUI(g_StringTree.allNodes[node_id]);
	var s = new USBStrings();
	s.unloadUI(g_StringTree.rootNode);
	g_StringMap = loadStringMap(s.strings, g_StringMap);
	g_StringSubject.notify();
}
/********************************************************************
 * Function: insertString
 *
 ********************************************************************/
function removeString(node_id)
{
	// Application layer coupling using the tree root name.
	var str_val = document.getElementById('text_'+node_id).value;
	g_StringMap.remove(str_val);
	g_StringTree.allNodes[node_id].remove();
	var s = new USBStrings();
	s.unloadUI(g_StringTree.rootNode);
	g_StringMap = loadStringMap(s.strings, g_StringMap);
	g_StringSubject.notify();
}
/********************************************************************
 * Function: validateStringDescr
 *
 ********************************************************************/
function validateStringDescr(object, node_id)
{
	var s = new USBStrings();
	s.unloadUI(g_StringTree.rootNode);
	g_StringMap = loadStringMap(s.strings, g_StringMap);
	g_StringSubject.notify();
}
/********************************************************************
 * Function: onLANGIDChange
 *
 ********************************************************************/
function onLANGIDChange(object)
{
}
/********************************************************************
 * Function: loadStringMap
 *
 ********************************************************************/
function loadStringMap(strings, theMap)
{
	if (theMap != null)
	{
		delete theMap;
	}
	theMap = new map();
	theMap.add('No String', 0);
	for (var i=0; i < strings.length; ++i)
	{
		theMap.add(strings[i].str_val, strings[i].hash);
	}
	return theMap;
}