// Object Tags
var s_MAP               = "MAP";
var s_PAIR              = "PAIR";
var s_ATTRIB_FIRST      = "FIRST";
var s_ATTRIB_SECOND     = "SECOND";

// Some helpers
function serializeInFromString(attrib, def)
{
    var sRet = def;
    if (attrib != null)
    {
        sRet = attrib;
    }
    return sRet;
}
function serializeInFromMap(map, attrib, def)
{
    var sRet = def;
    if (attrib != null)
    {
        sRet = map.reverse_lookup(attrib);
    }
    return sRet;
}
// Some containers
function pair(first,second)
{
	this.first = first;
	this.second = second;
}
pair.prototype.serializeIn = function (xmlElement)
{
    this.first = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_FIRST),"");
    this.second = serializeInFromString(xmlElement.getAttribute(s_ATTRIB_SECOND),"");
}
pair.prototype.PairSerializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_PAIR);
	xmlElement.setAttribute(s_ATTRIB_FIRST,		this.first);
	xmlElement.setAttribute(s_ATTRIB_SECOND,	this.second);
    return xmlElement;
}
function map()
{
	this.pairs = new Array();	// 
}
map.prototype.add = function (f,s)
{
	this.pairs[f] = new pair(f,s);

/*
	this.pairs[this.pairs.length] = new pair(null,null);
	this.pairs[this.pairs.length - 1].first = f; 
	this.pairs[this.pairs.length - 1].second = s; 
	this.hash();
*/
}
map.prototype.remove = function (f)
{
	
	var new_pairs = new map();

    for (j in this.pairs)
    {
        if (this.pairs[j] != j)
        {
            new_pairs.add(this.pairs[j].first, this.pairs[j].second);
        }
    }
    
    delete this.pairs;
    this.pairs = new_pairs.pairs;
/*
	var index = this.get_index(f);
	
	if (index != null)
	{
		this.pairs.splice(index, 1);
		this.hash();
	}
*/
}
map.prototype.get_index = function (f)
{
	var bRet = null;
	for (var i=0; i < this.pairs.length; i++)	// >
	{
		if (this.pairs[i].first == f)
		{
			bRet = i;
			break;
		}
	}
	return bRet;
}
map.prototype.hash = function ()
{
	for (var i  = 0; i  < this.pairs.length; i++)	// >
	{
		 this.pairs[ this.pairs[i].first] =  this.pairs[i];
	}
	for (var i  = 0; i  < this.length; i++)	// >
	{
		 this[ this[i].first] =  this[i];
	}
}
map.prototype.reverse_lookup = function (s)
{
	var bRet = null;
	for (j in this.pairs)
	{
		if (this.pairs[j].second == s)
		{
			bRet = this.pairs[j].first;
			break;
		}
	}
	return bRet;
}
map.prototype.serializeIn = function (xmlElement)
{
	var pairs = xmlElement.getElementsByTagName(s_PAIR);
    for (var i = 0; i < pairs.length; i++)	// >
	{
		var new_pair = new pair("","");
		new_pair.serializeIn(pairs[i]);
		this.add(new_pair.first, new_pair.second);
	}
    this.hash();
}
map.prototype.serializeOut = function (xmlDoc)
{
	var xmlElement = xmlDoc.createElement(s_MAP);
	// Add default attributes here
	// None
	for (var j in this.pairs)
	{
		xmlElement.appendChild(this.pairs[i].serializeOut(xmlDoc));	
	}
	return xmlElement;
}
/*
map.prototype.toString = function ()
{
	var rStr = new String();
	var comma = '';
	for (var i = 0; i < this.pairs.length; ++i)
	{
		rStr += comma;
		comma = ',';
		rStr += this.pairs[i].first;
		rStr += '(' + this.pairs[i].second + ')';
	}
	return rStr;
}
*/
function loadMap(list, theMap, p1, p2)
{
	if (theMap != null)
	{
		delete theMap;
	}
	theMap = new map();
	theMap.add('Null', 0);
	for (var i=0; i < list.length; ++i)
	{
		theMap.add(list[i].eval(p1), list[i].eval(p2));
	}
	return theMap;
}
