/********************************************************************
 * Global Object: ObserverHandler
 *
 ********************************************************************/
ObserverHandler = {
	nextID					: 0,
	getUniqueID				: function()			{ return this.nextID++; },
	allSubjects				: new map(),
	addSubject				: function(id, subject) { this.allSubjects.add(id,subject);},
	deleteSubject			: function(id)			{ this.allSubjects.remove(id);},
	addObserver				: function(id, observer){ this.allSubjects.pairs[id].second.addObserver(observer);}
}
/********************************************************************
 * Class: ObserverHandler
 *
 ********************************************************************/
function Observer(id, notify, ref)
{
//debugBox("Observer:: "+id+"::"+ref);
	// Check if the Subject exists
	this.subjectId = id;
	this.reference = ref;
	this.notify = null;
	if (notify != null)
	{
		this.notify = notify;
	}
	ObserverHandler.addObserver(id, this);	
}
/********************************************************************
 * Method: Observer.prototype.notify
 *
 ********************************************************************/
Observer.prototype.notify = function ()
{
	debugBox("Observer.prototype.notify::virtual");
}
/********************************************************************
 * Class: Subject
 *
 ********************************************************************/
function Subject(id)
{
//debugBox("Subject::"+id);
	this.observers = new Array();
	this.id = id;
	ObserverHandler.addSubject(id,this);
}
/********************************************************************
 * Method: Subject.prototype.addObserver
 *
 ********************************************************************/
Subject.prototype.addObserver = function (observer)
{
//debugBox("Subject.prototype.addObserver::");
	this.observers[this.observers.length] = observer;
}
/********************************************************************
 * Method: Subject.prototype.notify
 *
 ********************************************************************/
Subject.prototype.notify = function ()
{
	for (var i = 0; i < this.observers.length; ++i)
	{
		try {
			
			this.observers[i].notify(this.observers[i].reference);
		}
		catch (e)
		{
			// Do nothing
			//debugBox("Subject.prototype.notify::caught exception");
		}
	}
}

